-- Run these to update
-- for ver in wow_beta wowxptr wow; do curl https://wago.tools/db2/Map/csv\?product=$ver; done | grep -e "^[0-9]" | tr -d \" | awk -F, '{NF >= 28 ? typeId = $11 : typeId = $9; if (typeId != 0) printf "\t\t[%d] = {name = \"%s\", instanceTypeId = %d},\n",$1,$3,typeId}' |  sort -t ']' -k 1.4 -n | uniq | grep -v -e UNUSED -e unused -e DNT -e "NOT USED"
-- for ver in wow_classic_beta wow_classic_ptr wow_classic; do curl https://wago.tools/db2/Map/csv\?product=$ver; done | grep -e "^[0-9]" | tr -d \" | awk -F, '{NF >= 28 ? typeId = $11 : typeId = $9; if (typeId != 0) printf "\t\t[%d] = {name = \"%s\", instanceTypeId = %d},\n",$1,$3,typeId}' |  sort -t ']' -k 1.4 -n | uniq | grep -v -e UNUSED -e unused -e DNT -e "NOT USED"
-- TODO: re-add wow_classic_era_ptr, but something is broken on Wago and it gives retail results?
-- for ver in wow_classic_era; do curl https://wago.tools/db2/Map/csv\?product=$ver; done | grep -e "^[0-9]" | tr -d \" | awk -F, '{NF >= 28 ? typeId = $11 : typeId = $9; if (typeId != 0) printf "\t\t[%d] = {name = \"%s\", instanceTypeId = %d},\n",$1,$3,typeId}' |  sort -t ']' -k 1.4 -n | uniq | grep -v -e UNUSED -e unused -e DNT -e "NOT USED"
local data = DBM.Test.CreateSharedModule("Data.Instances", {
	Retail = {
		[30] = {name = "Alterac Valley", instanceTypeId = 0},
		[33] = {name = "Shadowfang Keep", instanceTypeId = 1},
		[34] = {name = "Stormwind Stockade", instanceTypeId = 1},
		[36] = {name = "Deadmines", instanceTypeId = 1},
		[43] = {name = "Wailing Caverns", instanceTypeId = 1},
		[47] = {name = "Razorfen Kraul", instanceTypeId = 1},
		[48] = {name = "Blackfathom Deeps", instanceTypeId = 1},
		[70] = {name = "Uldaman", instanceTypeId = 1},
		[90] = {name = "Gnomeregan", instanceTypeId = 1},
		[109] = {name = "Sunken Temple", instanceTypeId = 1},
		[129] = {name = "Razorfen Downs", instanceTypeId = 1},
		[169] = {name = "Emerald Dream", instanceTypeId = 2},
		[189] = {name = "Scarlet Monastery of Old", instanceTypeId = 1},
		[209] = {name = "Zul'Farrak", instanceTypeId = 1},
		[229] = {name = "Lower Blackrock Spire", instanceTypeId = 1},
		[230] = {name = "Blackrock Depths", instanceTypeId = 1},
		[249] = {name = "Onyxia's Lair", instanceTypeId = 2},
		[269] = {name = "Opening of the Dark Portal", instanceTypeId = 1},
		[289] = {name = "Scholomance", instanceTypeId = 1},
		[309] = {name = "Ancient Zul'Gurub", instanceTypeId = 1},
		[329] = {name = "Stratholme", instanceTypeId = 1},
		[349] = {name = "Maraudon", instanceTypeId = 1},
		[389] = {name = "Ragefire Chasm", instanceTypeId = 1},
		[409] = {name = "Molten Core", instanceTypeId = 2},
		[429] = {name = "Dire Maul", instanceTypeId = 1},
		[469] = {name = "Blackwing Lair", instanceTypeId = 2},
		[489] = {name = "Classic Warsong Gulch", instanceTypeId = 0},
		[509] = {name = "Ruins of Ahn'Qiraj", instanceTypeId = 2},
		[529] = {name = "Classic Arathi Basin", instanceTypeId = 0},
		[531] = {name = "Ahn'Qiraj Temple", instanceTypeId = 2},
		[532] = {name = "Karazhan", instanceTypeId = 2},
		[533] = {name = "Naxxramas", instanceTypeId = 2},
		[534] = {name = "The Battle for Mount Hyjal", instanceTypeId = 2},
		[540] = {name = "Hellfire Citadel: The Shattered Halls", instanceTypeId = 1},
		[542] = {name = "Hellfire Citadel: The Blood Furnace", instanceTypeId = 1},
		[543] = {name = "Hellfire Citadel: Ramparts", instanceTypeId = 1},
		[544] = {name = "Magtheridon's Lair", instanceTypeId = 2},
		[545] = {name = "Coilfang: The Steamvault", instanceTypeId = 1},
		[546] = {name = "Coilfang: The Underbog", instanceTypeId = 1},
		[547] = {name = "Coilfang: The Slave Pens", instanceTypeId = 1},
		[548] = {name = "Coilfang: Serpentshrine Cavern", instanceTypeId = 2},
		[550] = {name = "Tempest Keep", instanceTypeId = 2},
		[552] = {name = "Tempest Keep: The Arcatraz", instanceTypeId = 1},
		[553] = {name = "Tempest Keep: The Botanica", instanceTypeId = 1},
		[554] = {name = "Tempest Keep: The Mechanar", instanceTypeId = 1},
		[555] = {name = "Auchindoun: Shadow Labyrinth", instanceTypeId = 1},
		[556] = {name = "Auchindoun: Sethekk Halls", instanceTypeId = 1},
		[557] = {name = "Auchindoun: Mana-Tombs", instanceTypeId = 1},
		[558] = {name = "Auchindoun: Auchenai Crypts", instanceTypeId = 1},
		[559] = {name = "Nagrand Arena (old)", instanceTypeId = 4},
		[560] = {name = "The Escape from Durnholde", instanceTypeId = 1},
		[562] = {name = "zzOldBlade's Edge Arena", instanceTypeId = 4},
		[564] = {name = "Black Temple", instanceTypeId = 2},
		[565] = {name = "Gruul's Lair", instanceTypeId = 2},
		[566] = {name = "Eye of the Storm", instanceTypeId = 0},
		[568] = {name = "Zul'Aman", instanceTypeId = 1},
		[572] = {name = "Ruins of Lordaeron", instanceTypeId = 4},
		[574] = {name = "Utgarde Keep", instanceTypeId = 1},
		[575] = {name = "Utgarde Pinnacle", instanceTypeId = 1},
		[576] = {name = "The Nexus", instanceTypeId = 1},
		[578] = {name = "The Oculus", instanceTypeId = 1},
		[580] = {name = "The Sunwell", instanceTypeId = 2},
		[585] = {name = "Magisters' Terrace", instanceTypeId = 1},
		[595] = {name = "The Culling of Stratholme", instanceTypeId = 1},
		[599] = {name = "Halls of Stone", instanceTypeId = 1},
		[600] = {name = "Drak'Tharon Keep", instanceTypeId = 1},
		[601] = {name = "Azjol-Nerub", instanceTypeId = 1},
		[602] = {name = "Halls of Lightning", instanceTypeId = 1},
		[603] = {name = "Ulduar", instanceTypeId = 2},
		[604] = {name = "Gundrak", instanceTypeId = 1},
		[607] = {name = "Strand of the Ancients", instanceTypeId = 0},
		[608] = {name = "Violet Hold", instanceTypeId = 1},
		[615] = {name = "The Obsidian Sanctum", instanceTypeId = 2},
		[616] = {name = "The Eye of Eternity", instanceTypeId = 2},
		[617] = {name = "Dalaran Sewers", instanceTypeId = 4},
		[618] = {name = "The Ring of Valor", instanceTypeId = 4},
		[619] = {name = "Ahn'kahet: The Old Kingdom", instanceTypeId = 1},
		[624] = {name = "Vault of Archavon", instanceTypeId = 2},
		[627] = {name = "Unused (DELETE ME)", instanceTypeId = 5},
		[628] = {name = "Isle of Conquest", instanceTypeId = 0},
		[631] = {name = "Icecrown Citadel", instanceTypeId = 2},
		[632] = {name = "The Forge of Souls", instanceTypeId = 1},
		[637] = {name = "Abyssal Maw Exterior", instanceTypeId = 1},
		[643] = {name = "Throne of the Tides", instanceTypeId = 1},
		[644] = {name = "Halls of Origination", instanceTypeId = 1},
		[645] = {name = "Blackrock Caverns", instanceTypeId = 1},
		[649] = {name = "Trial of the Crusader", instanceTypeId = 2},
		[650] = {name = "Trial of the Champion", instanceTypeId = 1},
		[657] = {name = "The Vortex Pinnacle", instanceTypeId = 1},
		[658] = {name = "Pit of Saron", instanceTypeId = 1},
		[668] = {name = "Halls of Reflection", instanceTypeId = 1},
		[669] = {name = "Blackwing Descent", instanceTypeId = 2},
		[670] = {name = "Grim Batol", instanceTypeId = 1},
		[671] = {name = "The Bastion of Twilight", instanceTypeId = 2},
		[720] = {name = "Firelands", instanceTypeId = 2},
		[721] = {name = "Firelands Terrain 2", instanceTypeId = 1},
		[724] = {name = "The Ruby Sanctum", instanceTypeId = 2},
		[725] = {name = "The Stonecore", instanceTypeId = 1},
		[726] = {name = "Twin Peaks", instanceTypeId = 0},
		[727] = {name = "Silvershard Mines", instanceTypeId = 0},
		[734] = {name = "Ahn'Qiraj Terrace", instanceTypeId = 1},
		[754] = {name = "Throne of the Four Winds", instanceTypeId = 2},
		[755] = {name = "Lost City of the Tol'vir", instanceTypeId = 1},
		[757] = {name = "Baradin Hold", instanceTypeId = 2},
		[761] = {name = "The Battle for Gilneas", instanceTypeId = 0},
		[859] = {name = "Zul'Gurub", instanceTypeId = 1},
		[930] = {name = "A Dark Place", instanceTypeId = 5},
		[938] = {name = "End Time", instanceTypeId = 1},
		[939] = {name = "Well of Eternity", instanceTypeId = 1},
		[940] = {name = "Hour of Twilight", instanceTypeId = 1},
		[951] = {name = "Nexus Legendary", instanceTypeId = 1},
		[959] = {name = "Shado-Pan Monastery", instanceTypeId = 1},
		[960] = {name = "Temple of the Jade Serpent", instanceTypeId = 1},
		[961] = {name = "Stormstout Brewery", instanceTypeId = 1},
		[962] = {name = "Gate of the Setting Sun", instanceTypeId = 1},
		[967] = {name = "Dragon Soul", instanceTypeId = 2},
		[968] = {name = "Rated Eye of the Storm", instanceTypeId = 0},
		[977] = {name = "Maelstrom Deathwing Fight", instanceTypeId = 1},
		[980] = {name = "Tol'Viron Arena", instanceTypeId = 4},
		[994] = {name = "Mogu'shan Palace", instanceTypeId = 1},
		[996] = {name = "Terrace of Endless Spring", instanceTypeId = 2},
		[998] = {name = "Temple of Kotmogu", instanceTypeId = 0},
		[999] = {name = "Theramore's Fall (H)", instanceTypeId = 5},
		[1000] = {name = "Theramore's Fall (A)", instanceTypeId = 5},
		[1001] = {name = "Scarlet Halls", instanceTypeId = 1},
		[1004] = {name = "Scarlet Monastery", instanceTypeId = 1},
		[1005] = {name = "A Brewing Storm", instanceTypeId = 5},
		[1007] = {name = "Scholomance", instanceTypeId = 1},
		[1008] = {name = "Mogu'shan Vaults", instanceTypeId = 2},
		[1009] = {name = "Heart of Fear", instanceTypeId = 2},
		[1011] = {name = "Siege of Niuzao Temple", instanceTypeId = 1},
		[1014] = {name = "Peak of Serenity", instanceTypeId = 5},
		[1024] = {name = "Greenstone Village", instanceTypeId = 5},
		[1030] = {name = "Crypt of Forgotten Kings", instanceTypeId = 5},
		[1031] = {name = "Arena of Annihilation", instanceTypeId = 5},
		[1032] = {name = "Pet Battle - Jade Forest", instanceTypeId = 1},
		[1035] = {name = "Temple of Kotmogu", instanceTypeId = 5},
		[1048] = {name = "Unga Ingoo", instanceTypeId = 5},
		[1050] = {name = "Assault on Zan'vess", instanceTypeId = 5},
		[1051] = {name = "Brewmoon Festival", instanceTypeId = 5},
		[1095] = {name = "Dagger in the Dark", instanceTypeId = 5},
		[1098] = {name = "Throne of Thunder", instanceTypeId = 2},
		[1099] = {name = "Naval Battle Scenario", instanceTypeId = 5},
		[1102] = {name = "Domination Point", instanceTypeId = 5},
		[1103] = {name = "Lion's Landing", instanceTypeId = 5},
		[1104] = {name = "A Little Patience", instanceTypeId = 5},
		[1105] = {name = "Deepwind Gorge (Legacy)", instanceTypeId = 0},
		[1112] = {name = "Pursuing the Black Harvest", instanceTypeId = 5},
		[1122] = {name = "City Siege - Mogu Island Progression Scenario", instanceTypeId = 5},
		[1123] = {name = "Lightning Forge - Mogu Island Progression Scenario", instanceTypeId = 5},
		[1124] = {name = "Shipyard - Mogu Island Progression Scenario", instanceTypeId = 5},
		[1125] = {name = "Alliance Hub - Mogu Island Progression Scenario", instanceTypeId = 5},
		[1126] = {name = "Mogu Island Progression Events", instanceTypeId = 5},
		[1127] = {name = "Final Gate - Mogu Island Progression Scenario", instanceTypeId = 5},
		[1130] = {name = "Blood in the Snow", instanceTypeId = 5},
		[1131] = {name = "The Secrets of Ragefire", instanceTypeId = 5},
		[1134] = {name = "The Tiger's Peak", instanceTypeId = 4},
		[1135] = {name = "Mogu Island Loot Room", instanceTypeId = 5},
		[1136] = {name = "Siege of Orgrimmar", instanceTypeId = 2},
		[1144] = {name = "Heart of the Old God Scenario", instanceTypeId = 5},
		[1148] = {name = "Proving Grounds", instanceTypeId = 5},
		[1152] = {name = "FW Horde Garrison Level 1", instanceTypeId = 1},
		[1153] = {name = "FW Horde Garrison Level 3", instanceTypeId = 1},
		[1154] = {name = "FW Horde Garrison Level 4", instanceTypeId = 1},
		[1155] = {name = "Stromgarde Keep", instanceTypeId = 5},
		[1157] = {name = "Halfhill Scenario", instanceTypeId = 5},
		[1158] = {name = "SMV Alliance Garrison Level 1", instanceTypeId = 1},
		[1159] = {name = "SMV Alliance Garrison Level 3", instanceTypeId = 1},
		[1160] = {name = "SMV Alliance Garrison Level 4", instanceTypeId = 1},
		[1161] = {name = "Celestial Tournament", instanceTypeId = 5},
		[1168] = {name = "The Purge Of Grommar - Scenario", instanceTypeId = 5},
		[1170] = {name = "Shado-Pan Showdown", instanceTypeId = 4},
		[1175] = {name = "Bloodmaul Slag Mines", instanceTypeId = 1},
		[1176] = {name = "Shadowmoon Burial Grounds", instanceTypeId = 1},
		[1182] = {name = "Auchindoun", instanceTypeId = 1},
		[1187] = {name = "GOR Alliance Garrison Level 1", instanceTypeId = 1},
		[1188] = {name = "GOR Alliance Garrison Level 2", instanceTypeId = 1},
		[1189] = {name = "GOR Alliance Garrison Level 3", instanceTypeId = 1},
		[1191] = {name = "Ashran", instanceTypeId = 0},
		[1195] = {name = "Iron Docks", instanceTypeId = 1},
		[1200] = {name = "Bonetown Scenario", instanceTypeId = 5},
		[1203] = {name = "Frostfire Finale Scenario", instanceTypeId = 5},
		[1205] = {name = "Blackrock Foundry", instanceTypeId = 2},
		[1207] = {name = "The Battle for Shattrath", instanceTypeId = 5},
		[1208] = {name = "Grimrail Depot", instanceTypeId = 1},
		[1209] = {name = "Skyreach", instanceTypeId = 1},
		[1228] = {name = "Highmaul", instanceTypeId = 2},
		[1232] = {name = "GOR Horde Garrison Level 0", instanceTypeId = 1},
		[1233] = {name = "GOR Horde Garrison Level 3", instanceTypeId = 1},
		[1234] = {name = "TAL Alliance Garrison Level 0", instanceTypeId = 1},
		[1235] = {name = "TAL Alliance Garrison Level 3", instanceTypeId = 1},
		[1236] = {name = "TAL Horde Garrison Level 0", instanceTypeId = 1},
		[1237] = {name = "TAL Horde Garrison Level 3", instanceTypeId = 1},
		[1238] = {name = "SOA Alliance Garrison Level 0", instanceTypeId = 1},
		[1239] = {name = "SOA Alliance Garrison Level 3", instanceTypeId = 1},
		[1240] = {name = "SOA Horde Garrison Level 0", instanceTypeId = 1},
		[1241] = {name = "SOA Horde Garrison Level 3", instanceTypeId = 1},
		[1242] = {name = "NAG Alliance Garrison Level 0", instanceTypeId = 1},
		[1243] = {name = "NAG Alliance Garrison Level 3", instanceTypeId = 1},
		[1244] = {name = "NAG Horde Garrison Level 0", instanceTypeId = 1},
		[1245] = {name = "NAG Horde Garrison Level 3", instanceTypeId = 1},
		[1266] = {name = "Circle of Blood Scenario", instanceTypeId = 5},
		[1268] = {name = "Teron'gor's Confrontation", instanceTypeId = 1},
		[1277] = {name = "Defense of Karabor", instanceTypeId = 5},
		[1279] = {name = "The Everbloom", instanceTypeId = 1},
		[1280] = {name = "Southshore vs. Tarren Mill", instanceTypeId = 3},
		[1327] = {name = "Outdoor Garrison - Construction Plot", instanceTypeId = 4},
		[1328] = {name = "Outdoor Garrison - Construction Plot", instanceTypeId = 4},
		[1329] = {name = "Grommashar Scenario", instanceTypeId = 5},
		[1330] = {name = "FW Horde Garrison Level 2", instanceTypeId = 1},
		[1331] = {name = "SMV Alliance Garrison Level 2", instanceTypeId = 1},
		[1358] = {name = "Upper Blackrock Spire", instanceTypeId = 1},
		[1374] = {name = "Auchindoun Quest", instanceTypeId = 5},
		[1402] = {name = "Gorgrond Finale", instanceTypeId = 5},
		[1431] = {name = "The Coliseum", instanceTypeId = 5},
		[1446] = {name = "Outdoor Garrison - Construction Plot", instanceTypeId = 4},
		[1447] = {name = "Outdoor Garrison - Construction Plot", instanceTypeId = 4},
		[1448] = {name = "Hellfire Citadel", instanceTypeId = 2},
		[1451] = {name = "Tanaan Legion Test", instanceTypeId = 5},
		[1453] = {name = "Scourge of Northshire", instanceTypeId = 5},
		[1454] = {name = "The Broken Shore (old - delete)", instanceTypeId = 5},
		[1455] = {name = "Edge of Reality", instanceTypeId = 5},
		[1456] = {name = "Eye of Azshara", instanceTypeId = 1},
		[1458] = {name = "Neltharion's Lair", instanceTypeId = 1},
		[1460] = {name = "Broken Shore Scenario", instanceTypeId = 5},
		[1461] = {name = "Azsuna Scenario", instanceTypeId = 5},
		[1466] = {name = "Darkheart Thicket", instanceTypeId = 1},
		[1475] = {name = "The Maw of Nashal", instanceTypeId = 5},
		[1477] = {name = "Halls of Valor", instanceTypeId = 1},
		[1478] = {name = "The Temple of Elune", instanceTypeId = 5},
		[1480] = {name = "Icecrown Citadel", instanceTypeId = 5},
		[1489] = {name = "Niskara", instanceTypeId = 5},
		[1492] = {name = "Maw of Souls", instanceTypeId = 1},
		[1493] = {name = "Vault of the Wardens", instanceTypeId = 1},
		[1494] = {name = "The Violet Hold", instanceTypeId = 5},
		[1495] = {name = "Shield's Rest", instanceTypeId = 5},
		[1498] = {name = "Felsoul Hold", instanceTypeId = 5},
		[1500] = {name = "Broken Shore", instanceTypeId = 5},
		[1501] = {name = "Black Rook Hold", instanceTypeId = 1},
		[1503] = {name = "Deepholm", instanceTypeId = 5},
		[1504] = {name = "Black Rook Hold Arena", instanceTypeId = 4},
		[1505] = {name = "Nagrand Arena", instanceTypeId = 4},
		[1511] = {name = "Tideskorn Harbor", instanceTypeId = 5},
		[1516] = {name = "The Arcway", instanceTypeId = 1},
		[1520] = {name = "The Emerald Nightmare", instanceTypeId = 2},
		[1522] = {name = "Dreadscar Rift", instanceTypeId = 5},
		[1523] = {name = "Defense of the Fel Hammer Scenario", instanceTypeId = 5},
		[1526] = {name = "Temple of the White Tiger", instanceTypeId = 5},
		[1528] = {name = "Skywall", instanceTypeId = 5},
		[1529] = {name = "Karazhan", instanceTypeId = 5},
		[1530] = {name = "The Nighthold", instanceTypeId = 2},
		[1533] = {name = "Karazhan Catacombs", instanceTypeId = 5},
		[1534] = {name = "Moonglade", instanceTypeId = 5},
		[1535] = {name = "Moonglade", instanceTypeId = 1},
		[1536] = {name = "Ursocs Lair", instanceTypeId = 5},
		[1539] = {name = "Tirisfal Glades", instanceTypeId = 5},
		[1541] = {name = "Terrace of Endless Spring", instanceTypeId = 5},
		[1544] = {name = "Assault on Violet Hold", instanceTypeId = 1},
		[1545] = {name = "Azsuna", instanceTypeId = 5},
		[1552] = {name = "Ashamane's Fall", instanceTypeId = 4},
		[1553] = {name = "Gloaming Reef", instanceTypeId = 5},
		[1554] = {name = "7.0 Boost Experience - Alliance", instanceTypeId = 1},
		[1557] = {name = "7.0 Boost Experience - Horde", instanceTypeId = 1},
		[1571] = {name = "Court of Stars", instanceTypeId = 1},
		[1572] = {name = "The Maelstrom", instanceTypeId = 5},
		[1579] = {name = "Ulduar", instanceTypeId = 5},
		[1580] = {name = "The Maelstrom", instanceTypeId = 5},
		[1582] = {name = "Delete", instanceTypeId = 5},
		[1583] = {name = "Nexus Vault", instanceTypeId = 5},
		[1594] = {name = "The MOTHERLODE!!", instanceTypeId = 1},
		[1599] = {name = "Nordrassil", instanceTypeId = 5},
		[1600] = {name = "Throne of the Tides (Artifact Scenario)", instanceTypeId = 5},
		[1603] = {name = "Throne of the Tides Scenario(DELETE)", instanceTypeId = 5},
		[1607] = {name = "Artifact - Acquisition - Subtlety", instanceTypeId = 5},
		[1609] = {name = "Temple of Storms", instanceTypeId = 5},
		[1610] = {name = "Artifact - Serenity Legion Scenario", instanceTypeId = 5},
		[1611] = {name = "Death Knight Campaign - Light's Hope Chapel", instanceTypeId = 5},
		[1612] = {name = "The Ruins of Falanaar", instanceTypeId = 5},
		[1616] = {name = "Faronaar", instanceTypeId = 5},
		[1617] = {name = "Death Knight Campaign - Undercity", instanceTypeId = 5},
		[1620] = {name = "Artifact - Stormwind", instanceTypeId = 5},
		[1621] = {name = "Black Temple - Legion", instanceTypeId = 5},
		[1622] = {name = "Telogrus Rift Scenario", instanceTypeId = 5},
		[1623] = {name = "Mage Campaign - The Oculus", instanceTypeId = 5},
		[1624] = {name = "Battle of Exodar", instanceTypeId = 5},
		[1625] = {name = "Trial of the Serpent", instanceTypeId = 5},
		[1626] = {name = "The Collapse - Suramar Scenario", instanceTypeId = 5},
		[1629] = {name = "Netherlight Temple", instanceTypeId = 5},
		[1630] = {name = "Tol Barad", instanceTypeId = 5},
		[1632] = {name = "The Arcway - Suramar Scenario", instanceTypeId = 5},
		[1646] = {name = "Black Rook Hold [Scenario]", instanceTypeId = 5},
		[1648] = {name = "Trial of Valor", instanceTypeId = 2},
		[1651] = {name = "Return to Karazhan", instanceTypeId = 1},
		[1653] = {name = "Great Dark Beyond", instanceTypeId = 5},
		[1662] = {name = "Suramar", instanceTypeId = 5},
		[1666] = {name = "The Assault on Broken Shore", instanceTypeId = 5},
		[1667] = {name = "Legion Ship - Vertical", instanceTypeId = 5},
		[1668] = {name = "Legion Ship - Horizontal", instanceTypeId = 5},
		[1672] = {name = "Blade's Edge Arena", instanceTypeId = 4},
		[1673] = {name = "The Eye of Eternity - Scenario", instanceTypeId = 5},
		[1676] = {name = "Tomb of Sargeras", instanceTypeId = 2},
		[1677] = {name = "Cathedral of Eternal Night", instanceTypeId = 1},
		[1681] = {name = "Arathi Basin Winter", instanceTypeId = 3},
		[1683] = {name = "Artifact - Gnomeregan", instanceTypeId = 5},
		[1684] = {name = "Dread Scar Rift - Warlock Scenario Platform", instanceTypeId = 5},
		[1687] = {name = "Wailing Caverns", instanceTypeId = 5},
		[1688] = {name = "Deadmines", instanceTypeId = 5},
		[1689] = {name = "The Eye of Eternity - Mage Class Mount", instanceTypeId = 5},
		[1691] = {name = "Cooking: Impossible", instanceTypeId = 0},
		[1693] = {name = "Stormstout Brewery - Monk Scenario", instanceTypeId = 5},
		[1694] = {name = "Gnomeregan", instanceTypeId = 5},
		[1695] = {name = "Battleship: Ruin", instanceTypeId = 5},
		[1698] = {name = "Artifact - Acquisition - Tank", instanceTypeId = 5},
		[1702] = {name = "Artifact - Highmountain - Dual Boss", instanceTypeId = 5},
		[1703] = {name = "Halls of Valor - Scenario", instanceTypeId = 5},
		[1704] = {name = "Legion Ship - Horizontal - Valsharah", instanceTypeId = 5},
		[1705] = {name = "Legion Ship - Horizontal - Azsuna", instanceTypeId = 5},
		[1706] = {name = "Legion Ship - Vertical - HighMountain", instanceTypeId = 5},
		[1707] = {name = "Legion Ship - Vertical - Stormheim", instanceTypeId = 5},
		[1708] = {name = "Stratholme - Paladin Class Mount", instanceTypeId = 5},
		[1710] = {name = "Black Rook Hold - Artifact Challenge", instanceTypeId = 5},
		[1712] = {name = "Antorus", instanceTypeId = 1},
		[1714] = {name = "Halls Of Valor - Warrior Class Mount", instanceTypeId = 5},
		[1715] = {name = "Battle for Blackrock Mountain", instanceTypeId = 3},
		[1719] = {name = "Dread Scar Rift - Warlock Mount Scenario", instanceTypeId = 5},
		[1723] = {name = "Coldridge Valley", instanceTypeId = 5},
		[1728] = {name = "Halls of Valor", instanceTypeId = 5},
		[1729] = {name = "The Eye of Eternity - Mage Class Mount (Shorter Version)", instanceTypeId = 5},
		[1730] = {name = "Shrine of Aviana Defense - Scenario", instanceTypeId = 5},
		[1731] = {name = "Druid Mount Finale - Scenario", instanceTypeId = 5},
		[1732] = {name = "Felwing Ledge - Demon Hunter Class Mount", instanceTypeId = 5},
		[1733] = {name = "Azeroth's Warning Scenario", instanceTypeId = 5},
		[1734] = {name = "Throne of the Four Winds - Shaman Class Mount", instanceTypeId = 5},
		[1735] = {name = "Frozen Wastes", instanceTypeId = 5},
		[1736] = {name = "The Ruby Sanctum", instanceTypeId = 5},
		[1737] = {name = "Pocket Dimension Akazamzaraks Hat Scenario", instanceTypeId = 5},
		[1738] = {name = "The Lost Glacier", instanceTypeId = 5},
		[1744] = {name = "Trial of Style", instanceTypeId = 5},
		[1746] = {name = "Tempest Keep: The Arcatraz", instanceTypeId = 5},
		[1753] = {name = "Seat of the Triumvirate", instanceTypeId = 1},
		[1754] = {name = "Freehold", instanceTypeId = 1},
		[1756] = {name = "The Deaths of Chromie", instanceTypeId = 5},
		[1760] = {name = "Lordaeron", instanceTypeId = 5},
		[1762] = {name = "Kings' Rest", instanceTypeId = 1},
		[1763] = {name = "Atal'Dazar", instanceTypeId = 1},
		[1764] = {name = "Endless Halls", instanceTypeId = 5},
		[1771] = {name = "Tol Dagor", instanceTypeId = 1},
		[1774] = {name = "Forge of Aeons", instanceTypeId = 5},
		[1782] = {name = "Seething Strand", instanceTypeId = 0},
		[1803] = {name = "Seething Shore", instanceTypeId = 3},
		[1812] = {name = "Suramar", instanceTypeId = 5},
		[1813] = {name = "Un'gol Ruins (Islands 1)", instanceTypeId = 5},
		[1814] = {name = "Havenswood (Islands 2)", instanceTypeId = 5},
		[1818] = {name = "Silvermoon City", instanceTypeId = 5},
		[1822] = {name = "Siege of Boralus", instanceTypeId = 1},
		[1825] = {name = "Hook Point", instanceTypeId = 4},
		[1840] = {name = "The Sunwell", instanceTypeId = 5},
		[1841] = {name = "The Underrot", instanceTypeId = 1},
		[1861] = {name = "Uldir", instanceTypeId = 2},
		[1862] = {name = "Waycrest Manor", instanceTypeId = 1},
		[1864] = {name = "Shrine of the Storm", instanceTypeId = 1},
		[1876] = {name = "Warfronts Arathi - Horde", instanceTypeId = 5},
		[1877] = {name = "Temple of Sethraliss", instanceTypeId = 1},
		[1879] = {name = "Jorundall (Islands 7)", instanceTypeId = 5},
		[1882] = {name = "Verdant Wilds (Islands 8)", instanceTypeId = 5},
		[1883] = {name = "Whispering Reef (Islands 10)", instanceTypeId = 5},
		[1884] = {name = "Siege of Orgrimmar - Mag'har Orc Unlock Scenario", instanceTypeId = 5},
		[1892] = {name = "The Rotting Mire (Islands 9)", instanceTypeId = 5},
		[1893] = {name = "The Dread Chain (Islands 4)", instanceTypeId = 5},
		[1897] = {name = "Molten Cay (Islands 6)", instanceTypeId = 5},
		[1898] = {name = "Skittering Hollow (Islands 5)", instanceTypeId = 5},
		[1904] = {name = "Stormwind Escape from Stockades", instanceTypeId = 5},
		[1906] = {name = "Zandalar Continent Finale", instanceTypeId = 5},
		[1907] = {name = "Snowblossom Village (Islands 3)", instanceTypeId = 5},
		[1911] = {name = "Mugambala", instanceTypeId = 4},
		[1917] = {name = "Gorgrond - Mag'har Scenario", instanceTypeId = 5},
		[1932] = {name = "Blackrock Depths - Dark Iron Scenario", instanceTypeId = 5},
		[1943] = {name = "Warfronts Arathi - Alliance", instanceTypeId = 5},
		[1944] = {name = "Thros", instanceTypeId = 1},
		[1949] = {name = "8.0 Boost Experience - Alliance", instanceTypeId = 1},
		[1950] = {name = "8.0 Boost Experience - Horde", instanceTypeId = 1},
		[1955] = {name = "Uncharted Island", instanceTypeId = 5},
		[2070] = {name = "Battle of Dazar'alor", instanceTypeId = 2},
		[2076] = {name = "Firelands - Dark Iron Dwarf", instanceTypeId = 5},
		[2096] = {name = "Crucible of Storms", instanceTypeId = 2},
		[2097] = {name = "Operation: Mechagon", instanceTypeId = 1},
		[2105] = {name = "Warfronts Darkshore - Alliance", instanceTypeId = 5},
		[2106] = {name = "Warsong Gulch", instanceTypeId = 0},
		[2107] = {name = "Arathi Basin", instanceTypeId = 0},
		[2111] = {name = "Warfronts Darkshore - Horde", instanceTypeId = 5},
		[2115] = {name = "8.1 Darkshore Scenario", instanceTypeId = 5},
		[2118] = {name = "Battle for Wintergrasp", instanceTypeId = 0},
		[2124] = {name = "Crestfall (Islands 11)", instanceTypeId = 5},
		[2125] = {name = "Zandalari Treasury", instanceTypeId = 5},
		[2134] = {name = "Tol Dagor Scenario", instanceTypeId = 5},
		[2155] = {name = "Halls of Stone Scenario", instanceTypeId = 5},
		[2161] = {name = "Maw Prototype - Torment Chambers", instanceTypeId = 5},
		[2162] = {name = "Torghast", instanceTypeId = 1},
		[2163] = {name = "Gnomeregan Scenario", instanceTypeId = 5},
		[2164] = {name = "The Eternal Palace", instanceTypeId = 2},
		[2167] = {name = "The Robodrome", instanceTypeId = 4},
		[2169] = {name = "Uldir Scenario", instanceTypeId = 5},
		[2170] = {name = "Tauren Heritage Scenario", instanceTypeId = 5},
		[2174] = {name = "Scarlet Halls", instanceTypeId = 1},
		[2177] = {name = "Arathi Basin Comp Stomp", instanceTypeId = 0},
		[2178] = {name = "The Prison of Ink", instanceTypeId = 5},
		[2179] = {name = "Stratholme Pet Dungeon", instanceTypeId = 5},
		[2180] = {name = "The Dreamgrove (Hearthstone Tavern)", instanceTypeId = 5},
		[2187] = {name = "Halls of Origination", instanceTypeId = 5},
		[2193] = {name = "Galakrond's Fall", instanceTypeId = 5},
		[2197] = {name = "Korrak's Revenge", instanceTypeId = 0},
		[2207] = {name = "Neltharion's Lair - HoA Scenario", instanceTypeId = 5},
		[2208] = {name = "Eastern Kingdoms - Vermillion Redoubt - HoA Scenario", instanceTypeId = 5},
		[2209] = {name = "Emerald Dream - HoA Scenario", instanceTypeId = 5},
		[2210] = {name = "Siege of Orgrimmar - Coup Scenario", instanceTypeId = 5},
		[2211] = {name = "Gilneas - Worgen Heritage Scenario", instanceTypeId = 5},
		[2212] = {name = "Horrific Vision of Orgrimmar", instanceTypeId = 5},
		[2213] = {name = "Horrific Vision of Stormwind", instanceTypeId = 5},
		[2214] = {name = "The Maelstrom - Heart of Azeroth", instanceTypeId = 5},
		[2217] = {name = "Ny'alotha", instanceTypeId = 1},
		[2223] = {name = "The Eye of Eternity - HoA Scenario", instanceTypeId = 5},
		[2232] = {name = "Karazhan Catacombs - HoA Scenario", instanceTypeId = 5},
		[2233] = {name = "Temple of the Jade Serpent - HoA Scenario", instanceTypeId = 1},
		[2235] = {name = "Caverns of Time - Anniversary", instanceTypeId = 2},
		[2236] = {name = "Darkmaul Citadel", instanceTypeId = 1},
		[2245] = {name = "Deepwind Gorge", instanceTypeId = 0},
		[2247] = {name = "Mogu'shan Scenario", instanceTypeId = 5},
		[2257] = {name = "Chamber of Heart - Scenario", instanceTypeId = 5},
		[2258] = {name = "Crapopolis - Scenario", instanceTypeId = 5},
		[2264] = {name = "Visions of N'Zoth - Orgrimmar - Engineering Test", instanceTypeId = 5},
		[2266] = {name = "Blackwing Descent Scenario", instanceTypeId = 5},
		[2278] = {name = "Revendreth Scenario", instanceTypeId = 5},
		[2282] = {name = "Blackrock Depths - Pet Dungeon", instanceTypeId = 5},
		[2284] = {name = "Sanguine Depths", instanceTypeId = 1},
		[2285] = {name = "Spires of Ascension", instanceTypeId = 1},
		[2286] = {name = "The Necrotic Wake", instanceTypeId = 1},
		[2287] = {name = "Halls of Atonement", instanceTypeId = 1},
		[2289] = {name = "Plaguefall", instanceTypeId = 1},
		[2290] = {name = "Mists of Tirna Scithe", instanceTypeId = 1},
		[2291] = {name = "De Other Side", instanceTypeId = 1},
		[2293] = {name = "Theater of Pain", instanceTypeId = 1},
		[2296] = {name = "Castle Nathria", instanceTypeId = 2},
		[2299] = {name = "Vision of Ysera Scenario", instanceTypeId = 5},
		[2300] = {name = "Redridge - 9xp Bastion", instanceTypeId = 5},
		[2303] = {name = "Ardenweald Zone Scenario", instanceTypeId = 5},
		[2304] = {name = "Ardenweald Tyrande Finale Scenario", instanceTypeId = 5},
		[2305] = {name = "Bastion Scenario", instanceTypeId = 5},
		[2308] = {name = "Bastion Night Warrior Finale - Ardenweald Covenant Scenario", instanceTypeId = 5},
		[2354] = {name = "Ardenweald Covenant Chapter 2 Scenario", instanceTypeId = 5},
		[2356] = {name = "Castle Nathria Scenario", instanceTypeId = 5},
		[2360] = {name = "Sinfall Scenario", instanceTypeId = 5},
		[2362] = {name = "Maldraxxus Covenant Finale Scenario", instanceTypeId = 5},
		[2363] = {name = "9.0 - Ardenweald - Garden - Queen's Conservatory", instanceTypeId = 5},
		[2371] = {name = "9.0 Ardenweald Covenant Finale Drust Scenario", instanceTypeId = 5},
		[2373] = {name = "Empyrean Domain", instanceTypeId = 4},
		[2375] = {name = "9.0 Bastion Arena - Path of Ascension", instanceTypeId = 5},
		[2441] = {name = "Tazavesh", instanceTypeId = 1},
		[2450] = {name = "Sanctum of Domination", instanceTypeId = 2},
		[2451] = {name = "Uldaman: Legacy of Tyr", instanceTypeId = 1},
		[2464] = {name = "9.1 Battle of Ardenweald", instanceTypeId = 5},
		[2465] = {name = "9.1 Andorhal - Kyrian Chapter Scenario", instanceTypeId = 5},
		[2471] = {name = "Torghast", instanceTypeId = 5},
		[2481] = {name = "Sepulcher of the First Ones", instanceTypeId = 2},
		[2504] = {name = "Path of the Primus", instanceTypeId = 5},
		[2509] = {name = "Maldraxxus Coliseum", instanceTypeId = 4},
		[2511] = {name = "Enigma Arena", instanceTypeId = 4},
		[2515] = {name = "The Azure Vault", instanceTypeId = 1},
		[2516] = {name = "The Nokhud Offensive", instanceTypeId = 1},
		[2519] = {name = "Neltharus", instanceTypeId = 1},
		[2520] = {name = "Brackenhide Hollow", instanceTypeId = 1},
		[2521] = {name = "Ruby Life Pools", instanceTypeId = 1},
		[2522] = {name = "Vault of the Incarnates", instanceTypeId = 2},
		[2526] = {name = "Algeth'ar Academy", instanceTypeId = 1},
		[2527] = {name = "Halls of Infusion", instanceTypeId = 1},
		[2547] = {name = "Enigma Crucible", instanceTypeId = 4},
		[2549] = {name = "Amirdrassil", instanceTypeId = 1},
		[2556] = {name = "Emerald Dreamway", instanceTypeId = 5},
		[2559] = {name = "Shadowlands", instanceTypeId = 2},
		[2563] = {name = "Nokhudon Proving Grounds", instanceTypeId = 4},
		[2569] = {name = "Aberrus", instanceTypeId = 1},
		[2574] = {name = "Dragon Isles", instanceTypeId = 2},
		[2579] = {name = "Dawn of the Infinite", instanceTypeId = 1},
		[2582] = {name = "Alterac Valley", instanceTypeId = 5},
		[2583] = {name = "Tyr's Fall Scenario", instanceTypeId = 5},
		[2586] = {name = "10.1.5 Time Rifts - Murloc (Azmerloth)", instanceTypeId = 5},
		[2587] = {name = "10.1.5 Time Rifts - Robot (A.Z.E.R.O.T.H.)", instanceTypeId = 5},
		[2590] = {name = "The Azure Vault", instanceTypeId = 5},
		[2593] = {name = "10.1.5 Time Rifts - Black Empire (Azq'roth)", instanceTypeId = 5},
		[2595] = {name = "10.1.5 Time Rifts - Demon (Azewrath)", instanceTypeId = 5},
		[2597] = {name = "10.1 Zaralek Caverns - Chapter 1 Scenario", instanceTypeId = 5},
		[2598] = {name = "Zaralek Caverns - Chapter 6 scenario", instanceTypeId = 5},
		[2599] = {name = "Zaralek Caverns - Chapter 6 Scenario", instanceTypeId = 5},
		[2600] = {name = "10.1 Zaralek Caverns - Chapter 6 Scenario", instanceTypeId = 5},
		[2625] = {name = "Deathwing's Final Moment", instanceTypeId = 5},
		[2634] = {name = "10.1.5 Time Rifts - HvA (The Warlands)", instanceTypeId = 5},
		[2635] = {name = "10.1.5 Time Rifts - Titan (Ulderoth)", instanceTypeId = 5},
		[2639] = {name = "10.1.5 Time Rifts - Scourge (Azmourne)", instanceTypeId = 5},
		[2644] = {name = "10.2.0 - Halls of Valor - Misfit Dragons", instanceTypeId = 5},
		[2645] = {name = "10.1.5 Scarlet Monastery - Headless Horseman Revamp", instanceTypeId = 1},
		[2648] = {name = "The Rookery", instanceTypeId = 1},
		[2649] = {name = "Priory of the Sacred Flame", instanceTypeId = 1},
		[2651] = {name = "Darkflame Cleft", instanceTypeId = 1},
		[2652] = {name = "The Stonevault", instanceTypeId = 1},
		[2653] = {name = "10.2 Scenario", instanceTypeId = 5},
		[2654] = {name = "10.2. Nighthold", instanceTypeId = 5},
		[2656] = {name = "Deephaul Ravine", instanceTypeId = 0},
		[2657] = {name = "Nerub-ar Palace", instanceTypeId = 2},
		[2660] = {name = "Ara-Kara", instanceTypeId = 1},
		[2661] = {name = "Cinderbrew Meadery", instanceTypeId = 1},
		[2662] = {name = "The Dawnbreaker", instanceTypeId = 1},
		[2664] = {name = "Fungal Folly", instanceTypeId = 5},
		[2669] = {name = "City of Threads", instanceTypeId = 1},
		[2679] = {name = "Mycomancer Cavern", instanceTypeId = 5},
		[2680] = {name = "Earthcrawl Mines", instanceTypeId = 5},
		[2681] = {name = "Kriegval's Rest", instanceTypeId = 5},
		[2682] = {name = "Zekvir's Lair", instanceTypeId = 5},
		[2683] = {name = "The Waterworks", instanceTypeId = 5},
		[2684] = {name = "The Dread Pit", instanceTypeId = 5},
		[2685] = {name = "Skittering Breach", instanceTypeId = 5},
		[2686] = {name = "Nightfall Sanctum", instanceTypeId = 5},
		[2687] = {name = "The Sinkhole", instanceTypeId = 5},
		[2688] = {name = "The Spiral Weave", instanceTypeId = 5},
		[2689] = {name = "Tak-Rethan Abyss", instanceTypeId = 5},
		[2690] = {name = "The Underkeep", instanceTypeId = 5},
		[2692] = {name = "Hall of Awakening", instanceTypeId = 5},
		[2695] = {name = "Void Zone: Arathi Highlands", instanceTypeId = 6},
		[2699] = {name = "New Candle", instanceTypeId = 1},
		[2710] = {name = "Awakening The Machine", instanceTypeId = 5},
		[2713] = {name = "11.0 - Campaign Finale Scenario", instanceTypeId = 5},
		[2716] = {name = "11.0 - Priory Scenario", instanceTypeId = 5},
		[2767] = {name = "The Sinkhole", instanceTypeId = 5},
		[2768] = {name = "Tak-Rethan Abyss", instanceTypeId = 5},
		[2774] = {name = "Khaz Algar", instanceTypeId = 2},
	},
	Classic = {
		[30] = {name = "Alterac Valley", instanceTypeId = 0},
		[33] = {name = "Shadowfang Keep", instanceTypeId = 1},
		[34] = {name = "Stormwind Stockade", instanceTypeId = 1},
		[36] = {name = "Deadmines", instanceTypeId = 1},
		[43] = {name = "Wailing Caverns", instanceTypeId = 1},
		[47] = {name = "Razorfen Kraul", instanceTypeId = 1},
		[48] = {name = "Blackfathom Deeps", instanceTypeId = 1},
		[70] = {name = "Uldaman", instanceTypeId = 1},
		[90] = {name = "Gnomeregan", instanceTypeId = 1},
		[109] = {name = "Sunken Temple", instanceTypeId = 1},
		[129] = {name = "Razorfen Downs", instanceTypeId = 1},
		[169] = {name = "Emerald Dream", instanceTypeId = 2},
		[189] = {name = "Scarlet Monastery", instanceTypeId = 1},
		[209] = {name = "Zul'Farrak", instanceTypeId = 1},
		[229] = {name = "Blackrock Spire", instanceTypeId = 1},
		[230] = {name = "Blackrock Depths", instanceTypeId = 1},
		[249] = {name = "Onyxia's Lair", instanceTypeId = 2},
		[269] = {name = "Opening of the Dark Portal", instanceTypeId = 1},
		[289] = {name = "Scholomance", instanceTypeId = 1},
		[309] = {name = "Ancient Zul'Gurub", instanceTypeId = 1},
		[329] = {name = "Stratholme", instanceTypeId = 1},
		[349] = {name = "Maraudon", instanceTypeId = 1},
		[389] = {name = "Ragefire Chasm", instanceTypeId = 1},
		[409] = {name = "Molten Core", instanceTypeId = 2},
		[429] = {name = "Dire Maul", instanceTypeId = 1},
		[469] = {name = "Blackwing Lair", instanceTypeId = 2},
		[489] = {name = "Warsong Gulch", instanceTypeId = 0},
		[509] = {name = "Ruins of Ahn'Qiraj", instanceTypeId = 2},
		[529] = {name = "Arathi Basin", instanceTypeId = 0},
		[531] = {name = "Ahn'Qiraj Temple", instanceTypeId = 2},
		[532] = {name = "Karazhan", instanceTypeId = 2},
		[533] = {name = "Naxxramas", instanceTypeId = 2},
		[534] = {name = "The Battle for Mount Hyjal", instanceTypeId = 2},
		[540] = {name = "Hellfire Citadel: The Shattered Halls", instanceTypeId = 1},
		[542] = {name = "Hellfire Citadel: The Blood Furnace", instanceTypeId = 1},
		[543] = {name = "Hellfire Citadel: Ramparts", instanceTypeId = 1},
		[544] = {name = "Magtheridon's Lair", instanceTypeId = 2},
		[545] = {name = "Coilfang: The Steamvault", instanceTypeId = 1},
		[546] = {name = "Coilfang: The Underbog", instanceTypeId = 1},
		[547] = {name = "Coilfang: The Slave Pens", instanceTypeId = 1},
		[548] = {name = "Coilfang: Serpentshrine Cavern", instanceTypeId = 2},
		[550] = {name = "Tempest Keep", instanceTypeId = 2},
		[552] = {name = "Tempest Keep: The Arcatraz", instanceTypeId = 1},
		[553] = {name = "Tempest Keep: The Botanica", instanceTypeId = 1},
		[554] = {name = "Tempest Keep: The Mechanar", instanceTypeId = 1},
		[555] = {name = "Auchindoun: Shadow Labyrinth", instanceTypeId = 1},
		[556] = {name = "Auchindoun: Sethekk Halls", instanceTypeId = 1},
		[557] = {name = "Auchindoun: Mana-Tombs", instanceTypeId = 1},
		[558] = {name = "Auchindoun: Auchenai Crypts", instanceTypeId = 1},
		[559] = {name = "Nagrand Arena", instanceTypeId = 4},
		[560] = {name = "The Escape From Durnholde", instanceTypeId = 1},
		[562] = {name = "Blade's Edge Arena", instanceTypeId = 4},
		[564] = {name = "Black Temple", instanceTypeId = 2},
		[565] = {name = "Gruul's Lair", instanceTypeId = 2},
		[566] = {name = "Eye of the Storm", instanceTypeId = 0},
		[568] = {name = "Zul'Aman", instanceTypeId = 1},
		[572] = {name = "Ruins of Lordaeron", instanceTypeId = 4},
		[574] = {name = "Utgarde Keep", instanceTypeId = 1},
		[575] = {name = "Utgarde Pinnacle", instanceTypeId = 1},
		[576] = {name = "The Nexus", instanceTypeId = 1},
		[578] = {name = "The Oculus", instanceTypeId = 1},
		[580] = {name = "The Sunwell", instanceTypeId = 2},
		[585] = {name = "Magister's Terrace", instanceTypeId = 1},
		[595] = {name = "The Culling of Stratholme", instanceTypeId = 1},
		[598] = {name = "Sunwell Fix (Unused)", instanceTypeId = 1},
		[599] = {name = "Halls of Stone", instanceTypeId = 1},
		[600] = {name = "Drak'Tharon Keep", instanceTypeId = 1},
		[601] = {name = "Azjol-Nerub", instanceTypeId = 1},
		[602] = {name = "Halls of Lightning", instanceTypeId = 1},
		[603] = {name = "Ulduar", instanceTypeId = 2},
		[604] = {name = "Gundrak", instanceTypeId = 1},
		[607] = {name = "Strand of the Ancients", instanceTypeId = 0},
		[608] = {name = "Violet Hold", instanceTypeId = 1},
		[615] = {name = "The Obsidian Sanctum", instanceTypeId = 2},
		[616] = {name = "The Eye of Eternity", instanceTypeId = 2},
		[617] = {name = "Dalaran Sewers", instanceTypeId = 4},
		[618] = {name = "The Ring of Valor", instanceTypeId = 4},
		[619] = {name = "Ahn'kahet: The Old Kingdom", instanceTypeId = 1},
		[624] = {name = "Vault of Archavon", instanceTypeId = 2},
		[628] = {name = "Isle of Conquest", instanceTypeId = 0},
		[631] = {name = "Icecrown Citadel", instanceTypeId = 2},
		[632] = {name = "The Forge of Souls", instanceTypeId = 1},
		[637] = {name = "Abyssal Maw Exterior", instanceTypeId = 1},
		[643] = {name = "Throne of the Tides", instanceTypeId = 1},
		[644] = {name = "Halls of Origination", instanceTypeId = 1},
		[645] = {name = "Blackrock Caverns", instanceTypeId = 1},
		[649] = {name = "Trial of the Crusader", instanceTypeId = 2},
		[650] = {name = "Trial of the Champion", instanceTypeId = 1},
		[657] = {name = "The Vortex Pinnacle", instanceTypeId = 1},
		[658] = {name = "Pit of Saron", instanceTypeId = 1},
		[668] = {name = "Halls of Reflection", instanceTypeId = 1},
		[669] = {name = "Blackwing Descent", instanceTypeId = 2},
		[670] = {name = "Grim Batol", instanceTypeId = 1},
		[671] = {name = "The Bastion of Twilight", instanceTypeId = 2},
		[720] = {name = "Firelands", instanceTypeId = 2},
		[721] = {name = "Firelands Terrain 2", instanceTypeId = 1},
		[724] = {name = "The Ruby Sanctum", instanceTypeId = 2},
		[725] = {name = "The Stonecore", instanceTypeId = 1},
		[726] = {name = "Twin Peaks", instanceTypeId = 0},
		[727] = {name = "STV Diamond Mine BG", instanceTypeId = 1},
		[734] = {name = "Ahn'Qiraj Terrace", instanceTypeId = 1},
		[754] = {name = "Throne of the Four Winds", instanceTypeId = 2},
		[755] = {name = "Lost City of the Tol'vir", instanceTypeId = 1},
		[757] = {name = "Baradin Hold", instanceTypeId = 2},
		[761] = {name = "The Battle for Gilneas", instanceTypeId = 0},
		[859] = {name = "Zul'Gurub", instanceTypeId = 1},
		[930] = {name = "Scenario: Alcaz Island", instanceTypeId = 1},
		[938] = {name = "End Time", instanceTypeId = 1},
		[939] = {name = "Well of Eternity", instanceTypeId = 1},
		[940] = {name = "Hour of Twilight", instanceTypeId = 1},
		[951] = {name = "Nexus Legendary", instanceTypeId = 1},
		[967] = {name = "Dragon Soul", instanceTypeId = 2},
		[968] = {name = "Rated Eye of the Storm", instanceTypeId = 0},
		[977] = {name = "Maelstrom Deathwing Fight", instanceTypeId = 1},
		[2118] = {name = "Wintergrasp", instanceTypeId = 0},
		[2755] = {name = "Battle for Tol Barad", instanceTypeId = 0},
	},
	ClassicEra = {
		[13] = {name = "Test Dungeon", instanceTypeId = 1},
		[29] = {name = "CashTest", instanceTypeId = 1},
		[30] = {name = "Alterac Valley", instanceTypeId = 0},
		[33] = {name = "Shadowfang Keep", instanceTypeId = 1},
		[34] = {name = "Stormwind Stockade", instanceTypeId = 1},
		[36] = {name = "Deadmines", instanceTypeId = 1},
		[43] = {name = "Wailing Caverns", instanceTypeId = 1},
		[47] = {name = "Razorfen Kraul", instanceTypeId = 1},
		[48] = {name = "Blackfathom Deeps", instanceTypeId = 1},
		[70] = {name = "Uldaman", instanceTypeId = 1},
		[90] = {name = "Gnomeregan", instanceTypeId = 1},
		[109] = {name = "Sunken Temple", instanceTypeId = 1},
		[129] = {name = "Razorfen Downs", instanceTypeId = 1},
		[169] = {name = "Emerald Dream", instanceTypeId = 2},
		[189] = {name = "Scarlet Monastery", instanceTypeId = 1},
		[209] = {name = "Zul'Farrak", instanceTypeId = 1},
		[229] = {name = "Blackrock Spire", instanceTypeId = 1},
		[230] = {name = "Blackrock Depths", instanceTypeId = 1},
		[249] = {name = "Onyxia's Lair", instanceTypeId = 2},
		[269] = {name = "Caverns of Time", instanceTypeId = 1},
		[289] = {name = "Scholomance", instanceTypeId = 1},
		[309] = {name = "Zul'Gurub", instanceTypeId = 2},
		[329] = {name = "Stratholme", instanceTypeId = 1},
		[349] = {name = "Maraudon", instanceTypeId = 1},
		[389] = {name = "Ragefire Chasm", instanceTypeId = 1},
		[409] = {name = "Molten Core", instanceTypeId = 2},
		[429] = {name = "Dire Maul", instanceTypeId = 1},
		[469] = {name = "Blackwing Lair", instanceTypeId = 2},
		[489] = {name = "Warsong Gulch", instanceTypeId = 0},
		[509] = {name = "Ruins of Ahn'Qiraj", instanceTypeId = 2},
		[529] = {name = "Arathi Basin", instanceTypeId = 0},
		[531] = {name = "Ahn'Qiraj Temple", instanceTypeId = 2},
		[533] = {name = "Naxxramas", instanceTypeId = 2},
		[2720] = {name = "The Searing Basin", instanceTypeId = 1},
		[2784] = {name = "Demon Fall Canyon", instanceTypeId = 1},
		[2789] = {name = "The Tainted Scar", instanceTypeId = 2},
		[2791] = {name = "Storm Cliffs", instanceTypeId = 2},
	},
})

data.SeasonOfDiscovery = data.ClassicEra

return data
