# Changelog

## Changed in v40

* Hallowfall: add a giant Beledar phase-change indicator to the map
* Show the status for Delve achievements on their world map entrances
* Add a few more weekly reputation rewards
* Fix for the account-level checking of weekly reputation rewards

## Changed in v39

* Delves: add The Spiral Weave, Tak-Rethan Abyss, and The Underkeep
* Ringing Deeps: add the weekly reputation for Disturbed Earthgorger

## Changed in v38

* Isle of Dorn:
    * Added the hiding place for obtaining Dog as a pet, if you've brought him with you from Pandaria to Dalaran.
    * More weekly reputation rewards.
* Ringing Deeps: more weekly reputation rewards.
* New filter option for treasures, so they can be turned down to only show "notable" ones just like the rares. You can use this to not be shown treasures you found on other characters, mostly.
* New setting to allow achievement-progress from other characters to count for completion. This won't make a huge difference in this expansion, because with warbands *most* achievements have shared criteria-progress between characters already.

## Changed in v37

* Azj-Kahet:
    * The treasure quests apparently got shuffled around a bit somewhere between the beta and now, so fixed various questids
    * Added most of the remaining reputation rewards
    * Flag Tka'ktath's mount item as only dropping at level 80
* Hallowfall: added some more reputation rewards, fixed a typo in the quest ID for the Horror of the Shallows' reputation reward, and explained how to access Croakit
* Fixed some weird interactions around the notability settings for mobs that have quest-items and transmog

## Changed in v36

* Hallowfall: improve Beledar's Spawn -- show the time until the shadow phase via entertaining abuse of the
conditions system, add it to a group so it can be easily individually
toggled because there's a lot of spawn points... also, add the weekly reputation reward
* Hallowfall: add a bunch of weekly reputation rewards and make some minor tweaks
* Azj-Kahet: start on weekly reputation rewards

## Changed in v35

* Provide settings for what counts as "notable" -- you can turn off things you don't care about now
* Gather more of the weekly reputation quests, mostly from Ringing Deeps
* Fix one last glyph in Azj-Kahet that wasn't clearing properly, thanks Christof Bruyland!

## Changed in v34

* Starting on tracking the weekly reputation from rares
* Only count loot for notable mobs if it's likely to drop
* Highlight notable loot in the tooltips if you're emphasizing notable mobs
* Fix an issue where learning a new appearance from killing a mob wouldn't immediately flag that item as learned
* Fairly massive backend rewrite of the loot system to support reputation being included; hopefully there aren't any terrible new bugs...

## Changed in v33

* More loot added to rares
* Added some of the Elusive rares, and gated them behind you knowing Skinning
* Isle of Dorn: fix the coords for Clawbreaker K'zithix, remove the Rowdy Rubble which doesn't seem to be appearing

## Changed in v32

* Show my tooltips for races on the Blizzard race POIs when enabled (in the Blizzard filters menu)
* Dornogal: Tome of Polymorph: Mosswool
* Fix non-npc non-treasure points without completion from being considered "found" always
* Mostly for myself, but just in case... you can now alt-click the map button to quickly toggle showing found points

## Changed in v31

* Change how the "show npcs" setting works: it now has a submenu that lets you choose a filter, where you can choose to see *all* npcs, only npcs that you can currently get loot from (the default), or only npcs that you can get "notable" loot from
* New setting to control whether unlearned transmog appearances count as notable
* New setting to add some emphasis to the icons for NPCs that are notable
* Fix the "show treasure" setting so that it *only* affects treasures -- it was also controlling other non-npc points

## Changed in v30

* Ringing Deeps: added locations for To All The Slimes I Love (hidden by default)
* Ringing Deeps: give the Spore-Infused Shalewing a route
* Ringing Deeps: add more locations for the rough shards for the Dusty Prospector's Chest
* Hallowfall: consolidate some of the close-together Missing Lynx

## Changed in v29

* Delves: added Skittering Breach, The Sinkhole, and Nightfall Sanctum
* Fix display of skyriding glyphs in Hallowfall and Azj-Kahet

## Changed in v28

* Added the Flat Earthen achievment
* More loot added to rares

## Changed in v27

* Behavior change: count *exact* items for transmog-collection, rather than just appearance-from-any-item; previous behavior is available as a toggle in the settings
* Rearranged the settings a bunch, because they were getting to be a bit cluttered
* Fixed "open HandyNotes options" from the overlay dropdown so it properly goes all the way to the plugin's settings

## Changed in v26

* Hallowfall: Parasidious found (only one more adventurer rare remains missing!)
* More loot across all zones
* Fix group-names not showing properly in the main HandyNotes settings dialog

## Changed in v25

* Isle of Dorn: more loot for rares, thank Preheat!
* Hallowfall: added the Sky-Captain's Sunken Cache, thanks Marthammor!
* Azj-Kahet: added the Smelling History and Bookworm achievements

## Changed in v24

* Azj-Kahet: lots of new loot

## Changed in v23

* Ringing Deeps: added the Gobblin' with Glublurb achievement
* Isle of Dorn: improve the final display of the Mosswool Flower

## Changed in v22

* Hallowfall: lots of new loot
* Fixed the locations for some profession knowledge treasures that had moved since the beta (mostly in Dornogal)
* Fixed the position of one chest in Kriegval's Rest

## Changed in v21

* Ringing Deeps: lots of new loot
* Delves add some loot variation
* Isle of Dorn: fix typo that was making the Pearlescent Shellcrabs show up when they shouldn't

## Changed in v20

* Ringing Deeps: Lurker of the Deeps has been found by the secret-finding discord

## Changed in v19

* Isle of Dorn: lots of new loot

## Changed in v18

* Hide the Turtle's Thanks treasure in Dornogal before it's actually present

## Changed in v17

* Support Map Pin Enhanced for waypoints

## Changed in v16

* Locations and timing-display for all the races
* Add Regurgitated Mole Reins to Lurker of the Deeps based on the mount journal

## Changed in v15

* Delves: The Waterworks, The Dread Pit
* Show delve chests on the minimap as well

## Changed in v14

* Azj-Kahet: found Silk-Spun Supplies, Concealed Contraband
* Delves: Kriegval's Rest, Fungal Folly

## Changed in v13

* Isle of Dorn: consolidated the Violet Hold Prisoner nodes for better display
* Hallowfall: put the unknown-location rares that're tied to Defender of the Flame onto the map nearby as placeholders
* Azj-Kahet: found the Niffen Stash, loot from Webspeaker Grik'ik, some very incomplete data on the Smelling History and Bookworm achievements

## Changed in v12

* Isle of Dorn: improve the Turtle's Thanks treasure
* Hallowfall: found the Pride of Beledar
* Delves: added Mycomancer Cavern
* Assorted minor improvements

## Changed in v11

* Azj-Kahet: always show points on all layers of the map (e.g. a lower City of Threads point will still be visible if you're viewing upper Azj-Kahet)

## Changed in v10

* Ringing Deeps: added Notable Machines achievement
* Started gathering data on sturdy chests in delves, only Earthcrawl Mines included so far
* Minor data improvements in Isle of Dorn, Azj-Kahet
* More background work on gathering data for the races

## Changed in v9

* Azj-Kahet: found the last of the Adventurer rares
* Hallowfell: found more Adventurer rares, improved coordinates, and added loot
* Ringing Deeps: found Deathbound Husk, only one more to go...
* Background work on gathering data for the races

## Changed in v8

* Added Rocked to Sleep achievement
* Found more rares in Ringing Deeps
* General data improvements in Ringing Deeps

## Changed in v7

* Data improvements in Isle of Dorn and Azj-Kahet

## Changed in v6

* Added Tka'ktath to Azj-Kahet, leading to a mount quest
* Added level requirements and updated coordinates for many treasures
* Glyph hunter: don't include the mount as loot, because it was interfering with hiding found glyphs
* Profession knowledge: don't show on the minimap, because they all have vignettes

## Changed in v5

* Added profession knowledge treasures

## Changed in v4

* Added Not So Quick Fix achievement

## Changed in v3

* Glyph Hunter: add the mount reward
* Hallowfall: The Missing Lynx achievement
* Label cosmetic loot in tooltips

## Changed in v2

* Added the Treasures achievement
* Added the Khaz Algar Lore Hunter achievement
* Added the Biblo Archivist achievement in Hallowfall

## Changed in v1

* Initial release, so that's a bit of a philosophical question really.
* So far it just has all the Adventurer rares.
