# HandyNotes: The War Within Treasures and Rares

A [HandyNotes](https://www.curseforge.com/wow/addons/handynotes) plugin to show the War Within treasure items and rares on your map. (That means it **requires** [HandyNotes](https://www.curseforge.com/wow/addons/handynotes), so go install it as well.)

This includes:

* Items in treasure chests
* Items dropped by rare mobs
* Weekly reputation rewards from rare mobs
* [Khaz Algar Lore Hunter](https://www.wowhead.com/achievement=40762/khaz-algar-lore-hunter)
* [Biblo Archivist](https://www.wowhead.com/achievement=40622/biblo-archivist)
* [The Missing Lynx](https://www.wowhead.com/achievement=40625/the-missing-lynx)
* [Not So Quick Fix](https://www.wowhead.com/achievement=40473/not-so-quick-fix)
* [Rocked to Sleep](https://www.wowhead.com/achievement=40504/rocked-to-sleep)
* [Notable Machines](https://www.wowhead.com/achievement=40628/notable-machines)
* [Gobblin' with Glublurb](https://www.wowhead.com/achievement=40614/gobblin-with-glublurp)
* [Smelling History](https://www.wowhead.com/achievement=40542/smelling-history)
* [Bookworm](https://www.wowhead.com/achievement=40629/bookworm)
* Profession knowledge items
* Chests inside Delves
* Races for [Khaz Algar Completionist](https://www.wowhead.com/achievement=40354/khaz-algar-completionist-gold)
* The shadowy status of Beledar in Hallowfall

That's a lot. So, if you don't want to be overwhelmed, you can ask to only see "notable" rewards. By default that means only things that you can learn -- mounts, pets, transmog, etc -- but you can turn that down if you really only care about hunting mounts. You might want to turn this on if you're bringing an alt through, and don't care about collecting treasures that you already picked up on your main.

Items that you've already collected and mobs you've already killed won't be displayed. This uses the "flag" quests that the game relies on to keep track of the items. Sometimes these glitch; generally if they do so, you also won't have gotten achievement-credit / the item, so you'll likely still be interested in the item.

You can right-click on any point and do things: view related achievements, set waypoints, link its location to chat, and hide it.

To edit the settings, just right-click on the treasure chest icon that's added to the upper-right of the world map when you're in a zone this addon affects. You can get most of the relevant settings there, and you can open the HandyNotes settings dialog to see more.

## I liked this, can you help me find more things? / I hated this, what should I avoid?

Sure! Here's other addons I have that fill similar niches:

* [HandyNotes: Directions](https://www.curseforge.com/wow/addons/handynotes-directions) remembers places that guards have given you directions for
* [HandyNotes: The War Within Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes-war-within)
* [HandyNotes: Dragonflight Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes-dragonflight-treasures)
* [HandyNotes: Shadowlands Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes-shadowlands-treasures)
* [HandyNotes: Battle for Azeroth Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes-battle-for-azeroth-treasures)
* [HandyNotes: Legion (Broken Isles) Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes_legiontreasures)
* [HandyNotes: Warlords of Draenor Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes_treasurehunter)
* [HandyNotes: Mists of Pandaria Treasures and Rares](https://www.curseforge.com/wow/addons/handynotes_lostandfound)
* [HandyNotes: Wrath of the Lich King (Northrend)](https://www.curseforge.com/wow/addons/handynotes-wrath)
* [HandyNotes: Burning Crusade](https://www.curseforge.com/wow/addons/handynotes-burning-crusade)

These might also be useful if you're doing the sort of things that HandyNotes helps with:

* [QuestPointer](https://www.curseforge.com/wow/addons/questpointer) adds pointers to your minimap towards quests
* [AppearanceTooltip](https://www.curseforge.com/wow/addons/appearancetooltip) shows quick previews of transmog, and lots of badges on gear showing whether you know its appearance yet
* [SilverDragon](https://www.curseforge.com/wow/addons/silver-dragon) tries quite hard to tell you when rares or treasures are right by you
* [Handy Minimap Arrow](https://www.curseforge.com/wow/addons/handy-minimap-arrow) makes your player-arrow on the minimap appear *above* all the notes I'm adding to it
* [What's On The Map?](https://www.curseforge.com/wow/addons/whats-on-the-map) shows a list of the vignettes currently up nearby
* [Minimap Range Extender](https://www.curseforge.com/wow/addons/minimap-range-extender) makes map vignettes visible from further away

## Want to help?

If you'd like to submit corrections, please go into the settings as mentioned above and turn on "show quest ids". Then let me know the quest id for the node you want to correct, which will now appear in its tooltip.

If you'd like to submit a new node, you have two options:

1. Tell me where it is. I'll go find it eventually and track down the more obscure details I need to add it.
1. Gather these details yourself and send them to me:
    * Zone and coordinates.
    * What it gives you.
    * The quest id associated with it. This is the tricky one. The easiest way to get it is to install [QuestsChanged](https://www.wowace.com/addons/questschanged/) before you open the treasure, then open the treasure and check it to see what quest was triggered.
    * If you want to provide a route something follows, I recomment [RouteRecorder](https://www.curseforge.com/wow/addons/routerecorder).

## Problems?

If you have any problems, please use the [issues](https://github.com/kemayo/wow-handynotes-warwithin/issues/new) link -- Curseforge's comments are genuinely bad at for quickly notifying me of anything.
